<?php
class ome_event_trigger_delivery{

    /**
     *
     * 发货通知创建发起方法
     * @param string $wms_id 仓库类型ID
     * @param array $data 发货通知数据信息
     * @param string $sync 是否同步请求，true为同步，false异步，默认异步
     */
    public function create($wms_id,&$data, $sync = false){
        // $result = kernel::single('middleware_wms_request', $wms_id)->delivery_create($data, $sync);
        return kernel::single('erpapi_router_request')->set('wms',$wms_id)->delivery_create($data);
    }

    /**
     *
     * 发货通知创建发起的响应接收方法
     * @param array $data
     */
    public function create_callback($res){

    }

    /**
     *
     * 发货通知取消发起方法
     * @param string $wms_id 仓库类型ID
     * @param array $data 发货通知状态数据信息
     * @param string $sync 是否同步请求，true为同步，false异步，默认异步
     */
    public function cancel($wms_id, $data, $sync = false){
        // return kernel::single('middleware_wms_request', $wms_id)->delivery_cancel($data, $sync);
        return  kernel::single('erpapi_router_request')->set('wms',$wms_id)->delivery_cancel($data);
    }

    /**
     *
     * 发货通知取消发起方法
     * @param array $data
     */
    public function cancel_callback($res){

    }

    /**
     *
     * 发货通知暂停发起方法
     * @param string $wms_id 仓库类型ID
     * @param array $data 发货通知状态数据信息
     * @param string $sync 是否同步请求，true为同步，false异步，默认异步
     */
    public function pause($wms_id, $data, $sync = false){
        // return kernel::single('middleware_wms_request', $wms_id)->delivery_pause($data, $sync);
        return kernel::single('erpapi_router_request')->set('wms', $wms_id)->delivery_pause($data);
    }

    /**
     *
     * 发货通知暂停发起方法
     * @param array $data
     */
    public function pause_callback($res){

    }

    /**
     *
     * 发货通知恢复发起方法
     * @param string $wms_id 仓库类型ID
     * @param array $data 发货通知状态数据信息
     * @param string $sync 是否同步请求，true为同步，false异步，默认异步
     */
    public function renew($wms_id, $data, $sync = false){
        // return kernel::single('middleware_wms_request', $wms_id)->delivery_renew($data, $sync);
        return kernel::single('erpapi_router_request')->set('wms',$wms_id)->delivery_renew($data);
    }

    /**
     *
     * 发货通知恢复发起方法
     * @param array $data
     */
    public function renew_callback($res){

    }

    
    /**
     * 发货单查询
     * @param   
     * @return 
     * @access  public
     * @author cyyr24@sina.cn
     */
    function search($wms_id,&$sdf, $sync = false)
    {
        // $result = kernel::single('middleware_wms_request', $wms_id)->delivery_search($data, $sync);
        return kernel::single('erpapi_router_request')->set('wms',$wms_id)->delivery_search($data);
    }

    
    /**
     * 查询回调
     * @param   
     * @return  
     * @access  public
     * @author sunjing@shopex.cn
     */
    function search_callback($res)
    {
        
    }
}